plugins {
    kotlin("js")
}

kotlin {
    js(IR) {
        browser()
        binaries.executable()
    }
}


repositories {
    maven { url = uri("https://www.macrofocus.com/archiva/repository/public/") }
    maven { url = uri("https://www.macrofocus.com/archiva/repository/snapshots/") }
    mavenCentral()
    // Kotlin JS
    maven { url = uri("https://maven.pkg.jetbrains.space/kotlin/p/kotlin/kotlin-js-wrappers") }
    maven { url = uri("https://maven.pkg.jetbrains.space/public/p/kotlinx-html/maven/") }
}

dependencies {
    val kotlinxHtmlVersion: String by project
    val styledVersion: String by project
    val styledComponentVersion: String by project
    val kotlinReactVersion: String by project
    val kotlinReactRouterVersion: String by project
    val reactVersion: String by project
    val reactRouterVersion: String by project

    implementation("org.jetbrains.kotlinx:kotlinx-coroutines-core:1.5.0")

    implementation("org.jetbrains.kotlinx:kotlinx-html-js:$kotlinxHtmlVersion")
    implementation("org.jetbrains.kotlin-wrappers:kotlin-styled:$styledVersion")
    implementation(npm("styled-components", styledComponentVersion))

    //React, React DOM + Wrappers
    implementation("org.jetbrains.kotlin-wrappers:kotlin-react:$kotlinReactVersion")
    implementation("org.jetbrains.kotlin-wrappers:kotlin-react-dom:$kotlinReactVersion")
    implementation("org.jetbrains.kotlin-wrappers:kotlin-react-router-dom:$kotlinReactRouterVersion")
    implementation(npm("react", reactVersion))
    implementation(npm("react-dom", reactVersion))
    implementation(npm("react-router-dom", reactRouterVersion))

    val macrofocusVersion: String by project
    implementation("org.macrofocus:macrofocus-common:$macrofocusVersion")
    implementation("org.molap:molap:$macrofocusVersion")
    implementation("org.macrofocus:mkui:$macrofocusVersion")
    implementation("com.treemap:treemap:$macrofocusVersion")
}

tasks.register<Zip>("distZip") {
    archiveFileName.set("treemap-kotlin-react-2021.0.8.zip")
    destinationDirectory.set(file("$buildDir/distributions"))

    from(".") {
//        include("src/**")
        exclude("build/**")
        exclude("yarn.lock")
    }
}